using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace ZeichneFunktionen01
{
	/// <summary>
	/// Zusammenfassung fr Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.RadioButton radioButton1;
		private System.Windows.Forms.RadioButton radioButton2;
		private System.Windows.Forms.RadioButton radioButton3;
		/// <summary>
		/// Erforderliche Designervariable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			InitializeComponent();
   radioButton1.Checked=true;
		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.radioButton1 = new System.Windows.Forms.RadioButton();
			this.radioButton2 = new System.Windows.Forms.RadioButton();
			this.radioButton3 = new System.Windows.Forms.RadioButton();
			this.SuspendLayout();
			// 
			// radioButton1
			// 
			this.radioButton1.Location = new System.Drawing.Point(24, 24);
			this.radioButton1.Name = "radioButton1";
			this.radioButton1.Size = new System.Drawing.Size(120, 24);
			this.radioButton1.TabIndex = 0;
			this.radioButton1.Text = "Sinus-Funktion";
			this.radioButton1.CheckedChanged += new System.EventHandler(this.radioButton1_CheckedChanged);
			// 
			// radioButton2
			// 
			this.radioButton2.Location = new System.Drawing.Point(168, 24);
			this.radioButton2.Name = "radioButton2";
			this.radioButton2.Size = new System.Drawing.Size(136, 24);
			this.radioButton2.TabIndex = 1;
			this.radioButton2.Text = "Rechteck-Funktion";
			this.radioButton2.CheckedChanged += new System.EventHandler(this.radioButton2_CheckedChanged);
			// 
			// radioButton3
			// 
			this.radioButton3.Location = new System.Drawing.Point(352, 24);
			this.radioButton3.Name = "radioButton3";
			this.radioButton3.TabIndex = 2;
			this.radioButton3.Text = "Zufallszahhlen";
			this.radioButton3.CheckedChanged += new System.EventHandler(this.radioButton3_CheckedChanged);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(528, 326);
			this.Controls.Add(this.radioButton3);
			this.Controls.Add(this.radioButton2);
			this.Controls.Add(this.radioButton1);
			this.Name = "Form1";
			this.Text = "Zeichne Funktionen01";
			this.Resize += new System.EventHandler(this.Form1_Resize);
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.Form1_Paint);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Der Haupteinstiegspunkt fr die Anwendung.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void radioButton1_CheckedChanged(object sender, System.EventArgs e)
		{
			this.Refresh();
		}

		private void radioButton2_CheckedChanged(object sender, System.EventArgs e)
		{
		 this.Refresh();
		}

		private void radioButton3_CheckedChanged(object sender, System.EventArgs e)
		{
		 this.Refresh();
		}

		private void Form1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			// Erzeuge die Datenwerte--------------------------------------------------
			int nAnz=512;			// Anzahl der Datenwerte
			double [] fDaten= new double[nAnz];
			double A0=  2.0;		// Gleichanteil = 2 Volt
			double AM= 10.0;		// Amplitude = 10 Volt
			double fS=100.0;		// Signalfrequenz = 100Hz
			double fAB=6400.0;	// Abtastfrequenz 6400Hz =64 Punkte fr einen Sinus
			double fDelta=1.0/fAB;
			double fZeit=0.0;
			if(radioButton1.Checked)		// Sinus Funktion
			{
				for(int i=0;i<nAnz;i++)
				{
					fDaten[i]=A0+AM*Math.Sin(2*Math.PI*fS*fZeit);
					fZeit+=fDelta;
				}
			}
			else
			{
				if(radioButton2.Checked)		// Rechteckfunktion
				{
					for(int i=0;i<nAnz;i++)
					{
						if(Math.Sin(2*Math.PI*fS*fZeit)<0)fDaten[i]=-10;
						else fDaten[i]=10.0;fZeit+=fDelta;}
				}
				else																						// Zufallszahlen
				{
					Random rand=new Random();
					for(int i=0;i<nAnz;i++)
					{
						fDaten[i]=rand.NextDouble()*20.0 - 10.0;
					}
				}
			}
			// Anweisungen zum Zeichnen-----------------------------------------------
			Pen schwarzerStift= new Pen(Color.Black);	// Schwarzer Stift 
			int nUrx=10;						// Ursprung der x-Achse
			int nUry=199;						// Ursprung der y-Achse
			e.Graphics.DrawLine(schwarzerStift,nUrx,50,nUrx,349);// Zeichne x-Achse
			e.Graphics.DrawLine(schwarzerStift,nUrx,nUry,700,nUry);// Zeichne y-Achse
			// Wir schreiben einen Text in das Fenster
			Font arial16 = new Font("Arial",10);		// Definiere Schriftart
			e.Graphics.DrawString("64 Punkte pro Schwingung ",arial16,Brushes.Green,25,50);
			// Suche das Maximum in den Daten
			double fMax=fDaten[0];	
			for(int i=0;i<nAnz;i++)if(fMax<fDaten[i])fMax=fDaten[i];
			int nDeltaX=1;		// Schrittweite in x Richtung
			int nAmplitude = 100;
			int nXwert=0,nVon=0,nBis=512;			//  Zeichne von bis
			int nXalt=nUrx;
			int nYalt=nUry;
			int nXneu,nYneu;
			for(int i=nVon;i<nBis;i++)
			{
				nXneu=nUrx+nXwert;
				nYneu=nUry - (int)(nAmplitude*(fDaten[i]/fMax)); 
				e.Graphics.DrawLine(schwarzerStift,nXalt,nYalt,nXneu,nYneu);
				nXalt=nXneu;
				nYalt=nYneu;
				nXwert +=nDeltaX;
			}
		}

		private void Form1_Resize(object sender, System.EventArgs e)
		{
			ResizeRedraw=true;
		}
	}
}
